// ConvertEncoding.h
// Author: Scott Moore
// Permission to freely use, copy, modify, and distribute this source code 
// is hereby granted.  No representations are made about the
// suitability of this software for any purpose.  It is provided
// "as is" without express or implied warranty.
#ifndef _CONVERTENCODING_H
#define _CONVERTENCODING_H

#include <string.h>
#include <stdlib.h>
#include <wchar.h>

class ConvertEncoding
{
public:
  ConvertEncoding(const wchar_t * WideStr)
   : m_Wide(const_cast<wchar_t *> (WideStr)), m_Ansi(0), m_DeleteAnsi(true)
  {
  }
  ConvertEncoding(const char * AnsiStr)
   : m_Wide(0), m_Ansi(const_cast<char *> (AnsiStr)), m_DeleteAnsi(false)
  {
  }

  ~ConvertEncoding()
  {
    if (m_DeleteAnsi)
    {
      delete [] m_Ansi;
    }
    else
    {
      delete [] m_Wide;
    }
  }
    
  operator const wchar_t *(void)
  {
    if (m_Wide != 0 || m_Ansi == 0)
    {
      return m_Wide;
    }
    size_t Len;
    m_Wide = new wchar_t[Len = strlen(m_Ansi) + 1];
    mbstowcs(m_Wide, m_Ansi, Len);
    return m_Wide;
  }

  operator const char *(void)
  {
    if (m_Ansi != 0 || m_Wide == 0)
    {
      return m_Ansi;
    }
    size_t Len;
    m_Ansi = new char[Len = wcslen(m_Wide) + 1];
    wcstombs(m_Ansi, m_Wide, Len);
    return m_Ansi;
  }

private:
  wchar_t * m_Wide;
  char *    m_Ansi;
  bool      m_DeleteAnsi;
};




#endif