// This short module simulates the drivers of the final 
// destination of the compressed data, a flash memory.

#include "encoder.h"
#include <vector>

using namespace std;

static vector<WORD> twStorage;
static vector<WORD>::iterator twRead;

//
// this is the interface for the 16-bit processor,
// a driver written in C
//
extern "C" {
	void flash_write( WORD wSample )
	{
		twStorage.push_back( wSample);
		twRead = twStorage.begin();
	}
}


//
// the following two functions constitute the interface 
// for the PC, a driver written in C++
//

bool flash_read(WORD &wReadValue)
{
	if (twRead == twStorage.end()) return false;
	wReadValue = *twRead;
	twRead++;
	return true;
}

size_t flash_get_size( void )
{
	return twStorage.size();
}