/* This short module simulates the drivers of the final 
 * destination of the compressed data, a flash memory.
 */

#include <stddef.h>
#include "encoder.h"


#ifdef __cplusplus
extern "C" 
#endif
void flash_write( WORD );
/* Sequential write to the final output device. 
 * this is the interface for the 16-bit processor,
 * a driver written in C. */


#ifdef __cplusplus
bool flash_read(WORD &wReadValue);
/* returns true if the read was successful and wReadValue holds
 * the words stored with flash_write() in sequential calls. 
 * This is a function of the Flash Memory Driver on the PC. */

size_t flash_get_size( void );
/* returns the number of samples stored.
 * This is a function of the Flash Memory Driver on the PC. */
#endif

