/*
 * $Header: /home/gene/library/articles/boehm/RCS/xmalloc.c,v 1.2 2002/06/03 23:19:43 gene Exp $
 */

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <gc.h>

void *xmalloc (size_t sz)
{
  void *p;

  assert (sz > 0);
  p = GC_MALLOC (sz);
  if (p == NULL) {
    fprintf (stderr, "%s:%d: GC_MALLOC (%u) failed\n", __FILE__, __LINE__,
             (unsigned) sz);
    abort ();
  }
  return p;
}

void *xrealloc (void *p, size_t sz)
{
  p = GC_REALLOC (p, sz);
  if (p == NULL) {
    fprintf (stderr, "%s:%d: GC_MALLOC (%u) failed\n", __FILE__, __LINE__,
             (unsigned) sz);
    abort ();
  }
  return p;
}

void xfree (void *p)
{
  if (p != NULL) {
    GC_FREE (p);
  }
}
